import unittest
import sys
sys.path.insert(1, '..')
import evogression
from data_examples import surface_3d_data


class TestEquationOutput(unittest.TestCase):

    def test_model_equations_match_python_output(self):
        '''Ensures calculated predictions match those generated by the outputted Python regression function.'''
        models = [evogression.Evolution('z', surface_3d_data, creatures=30000, cycles=10, max_layers=2) for _ in range(100)]
        for model in models:
            py_eqn_model = model.model.python_regression_module_string()
            exec(py_eqn_model, globals())

            z_test = [model.predict(d, 'pred')['pred'] for d in surface_3d_data]
            z_py_test = [regression(d) for d in surface_3d_data]
            for z, z_py in zip(z_test, z_py_test):
                self.assertAlmostEqual(z, z_py, places=1)


if __name__ == '__main__':
    unittest.main()
